<?
/*
	图片处理类：缩略，裁剪，圆角，倾斜
	网站：http://www.ii888ii.com
						落伍 im123
*/
class resizeimage
{
   //图片类型
   var $type;
   //实际宽度
   var $width;
   //实际高度
   var $height;
   //改变后的宽度
   var $resize_width;
   //改变后的高度
   var $resize_height;
   //是否裁图
   var $cut;
   //源图象
   var $srcimg;
   //目标图象地址
   var $dstimg;
   //圆角源
   var $corner;
   var $im;

function resizeimage($img, $corner, $wid, $hei,$c, $corner_radius, $angle)
   {
       $this->srcimg = $img;
	   $this->corner = $corner;
       $this->resize_width = $wid;
       $this->resize_height = $hei;
       $this->cut = $c;
	   $this->corner_radius = $corner_radius;
	   $this->angle = $angle;
       //图片的类型
       $this->type = substr(strrchr($this->srcimg,"."),1);
       //初始化图象
       $this->initi_img();
       //目标图象地址
       $this -> dst_img();
       //--
       $this->width = imagesx($this->im);
       $this->height = imagesy($this->im);
       //生成图象
       $this->newimg();
       ImageDestroy ($this->im);
   }
   function newimg()
   {
       //改变后的图象的比例
       $resize_ratio = ($this->resize_width)/($this->resize_height);
       //实际图象的比例
       $ratio = ($this->width)/($this->height);
       if(($this->cut)=="1")
       //裁图
       {
           if($ratio>=$resize_ratio)
           //高度优先
           {
               $newimg = imagecreatetruecolor($this->resize_width,$this->resize_height);
               imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, $this->resize_width,$this->resize_height, (($this->height)*$resize_ratio), $this->height);
			   $tmp = $this->rounded_corner($newimg,$this->resize_width);
			   header("Content: image/png");
               imagepng ($tmp,$this->dstimg);
           }
           if($ratio<$resize_ratio)
           //宽度优先
           {
               $newimg = imagecreatetruecolor($this->resize_width,$this->resize_height);
               imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, $this->resize_width, $this->resize_height, $this->width, (($this->width)/$resize_ratio));
			   $tmp = $this->rounded_corner($newimg,$this->resize_width);
			   header("Content: image/png");
               imagepng ($tmp,$this->dstimg);
           }
       }
       else
       //不裁图
       {
           if($ratio>=$resize_ratio)
           {
               $newimg = imagecreatetruecolor($this->resize_width,($this->resize_width)/$ratio);
               imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, $this->resize_width, ($this->resize_width)/$ratio, $this->width, $this->height);
               ImageJpeg ($newimg,$this->dstimg);
           }
           if($ratio<$resize_ratio)
           {
               $newimg = imagecreatetruecolor(($this->resize_height)*$ratio,$this->resize_height);
               imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, ($this->resize_height)*$ratio, $this->resize_height, $this->width, $this->height);
               ImageJpeg ($newimg,$this->dstimg);
           }
       }
   }
   //初始化图象
   function initi_img()
   {
       if($this->type=="jpg")
       {
           $this->im = imagecreatefromjpeg($this->srcimg);
       }
       if($this->type=="gif")
       {
           $this->im = imagecreatefromgif($this->srcimg);
       }
       if($this->type=="png")
       {
           $this->im = imagecreatefrompng($this->srcimg);
       }
   }

   //处理圆角
   function rounded_corner($image,$size)
   {
		$corner = $this->corner_radius;
		$palette = ImageCreateTrueColor($size, $size);
		$found = false;
		while($found == false)
		{
			$r = rand(0, 255);
			$g = rand(0, 255);
			$b = rand(0, 255);
			if(imagecolorexact($new, $r, $g, $b) != (-1)) 
			{
				$colorcode = imagecolorallocate($palette, $r, $g, $b);
				$found = true;
			}
		}
		imagearc($image, $corner-1, $corner-1, $corner*2, $corner*2, 180, 270, $colorcode);
		imagefilltoborder($image, 0, 0, $colorcode, $colorcode);
		imagearc($image, $size-$corner, $corner-1, $corner*2, $corner*2, 270, 0, $colorcode);
		imagefilltoborder($new, $size, 0, $colorcode, $colorcode);
		imagearc($image, $corner-1, $size-$corner, $corner*2, $corner*2, 90, 180, $colorcode);
		imagefilltoborder($new, 0, $size, $colorcode, $colorcode);
		imagearc($image, $size-$corner, $size-$corner, $corner*2, $corner*2, 0, 90, $colorcode);
		imagefilltoborder($image, $size, $size, $colorcode, $colorcode);
		imagecolortransparent($image, $colorcode);
		$corner_source = imagecreatefrompng($this->corner);
		$corner_width = imagesx($corner_source);  
		$corner_height = imagesy($corner_source);  
		$corner_resized = ImageCreateTrueColor(80, 80);
		ImageCopyResampled($corner_resized, $corner_source, 0, 0, 0, 0, 80, 80, $corner_width, $corner_height);
		$corner_width = imagesx($corner_resized);  
		$corner_height = imagesy($corner_resized);
		$black = ImageColorAllocate($image,0,0,0);
		$dest_x = 1;  
		$dest_y = 1;  
		imagecolortransparent($corner_resized, $black); 
		imagecopymerge($corner_resized, $image, $dest_x, $dest_y, 0, 0, 78, 78, 100);
		return $corner_resized; 
   }

   //图象目标地址
   function dst_img()
   {
	   global $_SC;
       $full_length = strlen($this->srcimg);
       $type_length = strlen($this->type);
       $name_length = $full_length-$type_length;
       $name         = substr($this->srcimg,0,$name_length-1);
       $this->dstimg = "../icon/tmp/".$_SC['site_key'].".png";
   }
}
?>